// gsm_sample.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>

#include <Windows.h>

#include "libsangoma.h"
#include "sangoma_config.h"


typedef struct sangoma_hwprobe_reg
{
	int *callback(void*, int port_id);
}sangoma_hwprobe_reg_t;


/**************************************
Global variables
***************************************/
sangoma_hw_ports g_ports;

/**************************************
Function definitions 
***************************************/
void print_all_ports();


/**************************************
Function bodies
***************************************/
void print_all_ports()
{
	for(int i=0; i<g_ports.port_numbers; i++)
	{
		printf("Wanpipe%d  \t   card_model [%d]   firmware_version [%d]  pci_bus_number[%d]  pci_slot_number[%d]  port_number[%d] \n",
				g_ports.ports[i].wp_number, g_ports.ports[i].wp_hw_info.card_model,
				g_ports.ports[i].wp_hw_info.firmware_version,
				g_ports.ports[i].wp_hw_info.pci_bus_number,
				g_ports.ports[i].wp_hw_info.pci_slot_number,
				g_ports.ports[i].wp_hw_info.port_number
				);
	}
}

void zero_out_global_ports()
{
	memset(g_ports.ports, 0, sizeof(g_ports));
}





int _tmain(int argc, _TCHAR* argv[])
{
	uint16_t wp_index; 
	port_management_struct_t port_mgmt;
	uint16_t result = 0;
	HANDLE wp_handle = INVALID_HANDLE_VALUE;

	memset(&port_mgmt, 0, sizeof(port_mgmt));
	zero_out_global_ports();



	for(wp_index=0; wp_index<(WP_MAX_PORTS); wp_index++) 
	{
		wp_handle = INVALID_HANDLE_VALUE;
		wp_handle = sangoma_open_driver_ctrl(wp_index);
		if(wp_handle == INVALID_HANDLE_VALUE) {
			continue;
		} 

		result = sangoma_driver_get_hw_info(wp_handle, &port_mgmt, wp_index);
		if(result) {
			sangoma_close(&wp_handle);
			break;
		}

		memcpy(&g_ports.ports[g_ports.port_numbers].wp_hw_info, port_mgmt.data, sizeof(hardware_info_t));
		g_ports.ports[g_ports.port_numbers].wp_number = wp_index;
		sangoma_close(&wp_handle);

		g_ports.port_numbers++;
	}

	print_all_ports();

	{
		int in;
		in = getch();
	}
	return 0;
}

/*-----------------------------------*/
/* APP CODE HERE */


void* sangoma_ports[MAX_PORTS];

int app_hw_probe_per_port(void *sangoma_hw_port)
{
	int port_id=sangoma_hw_port_get_id(sangoma_hw_port);
	printf("Found Sangoma Port %i\n",port_id);

	printf("Type= %s\n", sangoma_hw_port_get_id(sangoma_hw_port), sangoma_config_hwprobe_get_type(sangoma_hw_port))
	sangoma_ports[port_id]=sangoma_hw_port;
}


int app_config_sangoma_port(void *sangoma_port)
{
	


}

int _tmain(int argc, _TCHAR* argv[])
{
	sangoma_hwprobe_reg_t sng_hw_probe;

	sangoma_hw_probe.callback=app_hw_probe_callback()
	sangoma_config_hwprobe(sangoam_hw_probe);


	for (port=1;port<MAX_PORTS;port++) {
		
		void* sangoma_port=sangoma_ports[port];
		if (!sangoma_ports) {
			break;
		}	

		/* Configure Sangoma Port */


		

	}
}


